Index: palm/trunk/SOURCE/chem_emissions_mod.f90
===================================================================
--- palm/trunk/SOURCE/chem_emissions_mod.f90	(revision 3454)
+++ palm/trunk/SOURCE/chem_emissions_mod.f90	(revision 3458)
@@ -1448,9 +1427,9 @@
                          !>Other Species: inputs are micromoles
                          !                 ppm/s *m *kg/m^3                
-                            surf_lsm_h%cssws(match_spec_model(ispec),m) = emiss_factor_side(match_spec_input(ispec)) * &
+                            surf_lsm_h%cssws(match_spec_model(ispec),m) = emiss_factor_side(match_spec_input(ispec)) *   &
                          !                                                    micromoles/(m^2*s)
-                                                                          emis_distribution(1,j,i,ispec) *             &
-                         !                                                    m**3/Nmole
-                                                                          conv_to_ratio(k,j,i)*                        &
+                                                                          emis_distribution(1,j,i,ispec) *              &
+                         !                                                    m^3/Nmole
+                                                                          conv_to_ratio(k,j,i)*                         &       
                          !                                                    kg/m^3
                                                                           rho_air(k)   
@@ -1486,43 +1465,47 @@
                    j = surf_def_h(0)%j(m)
 
-                   !> Distinguish between PMs (no needing conversion in ppms), 
-                   !  VOC (already converted to moles/(m**2*s) using conv_factors: they do not need molar masses for their conversion to PPMs ) and
-                   ! other Species (still expressed in Kg/(m**2*s) at this point)
-
-                   !> PMs
-                   IF (TRIM(spc_names(match_spec_model(ispec)))=="PM1"                                   &
-                         .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM25"                           &
-                         .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM10") THEN
+                   IF ( emis_distribution(1,j,i,ispec) > 0.0_wp )  THEN
+
+
+                      !> Distinguish between PMs (no needing conversion in ppms), 
+                      !  VOC (already converted to moles/(m**2*s) using conv_factors: they do not need molar masses for their conversion to PPMs ) and
+                      ! other Species (still expressed in Kg/(m**2*s) at this point)
+
+                      !> PMs
+                      IF (TRIM(spc_names(match_spec_model(ispec)))=="PM1" .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM25"  &
+                             .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM10") THEN
                    
-                      !            kg/(m^2*s) *kg/m^3                         kg/(m^2*s)                 
-                      surf_def_h(0)%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec)*   &
-                      !                                                  kg/m^3
-                                                                       rho_air(k)   
- 
- 
-                   ELSE
-
-                      !> VOCs
-                      IF ( len_index_voc .GT. 0 .AND. emt_att%species_name(match_spec_input(ispec))=="VOC" ) THEN
-                         !          ( ppm/s) * m * kg/m^3                         mole/(m**2/s)   
-                         surf_def_h(0)%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec) *      &
-                                                                         !    m**3/mole          ppm
-                                                                          conv_to_ratio(k,j,i)*ratio2ppm *      &
-                      !                                                    kg/m^3
-                                                                          rho_air(k)   
-
-
-                      !> OTHER SPECIES
+                         !            kg/(m^2*s) *kg/m^3                         kg/(m^2*s)                 
+                         surf_def_h(0)%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec)*   &
+                         !                                                  kg/m^3
+                                                                          rho_air(nzb)   
+ 
+ 
                       ELSE
 
-                         !               ( ppm/s )*m  * kg/m^3                      kg/(m**2/s)                      
-                         surf_def_h(0)%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec) *      &
-                                                                            !  mole/Kg        
-                                                                          (1/emt_att%xm(ispec))*                &
-                         !                                                    m**3/mole          ppm
-                                                                          conv_to_ratio(k,j,i)*ratio2ppm*       &
-                         !                                                  kg/m^3
-                                                                          rho_air(k)   
-  
+                         !> VOCs
+                         IF ( len_index_voc .GT. 0 .AND. emt_att%species_name(match_spec_input(ispec))=="VOC" ) THEN
+                            !          ( ppm/s) * m * kg/m^3                         mole/(m^2/s)   
+                            surf_def_h(0)%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec) *      &
+                                                                            !    m^3/mole          ppm
+                                                                             conv_to_ratio(nzb,j,i)*ratio2ppm *      &
+                         !                                                    kg/m^3
+                                                                             rho_air(nzb)   
+
+
+                         !> OTHER SPECIES
+                         ELSE
+
+                            !               ( ppm/s )*m  * kg/m^3                      kg/(m^2/s)                      
+                            surf_def_h(0)%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec) *      &
+                                                                               !  mole/Kg        
+                                                                             (1/emt_att%xm(ispec))*                &
+                            !                                                    m^3/mole          ppm
+                                                                             conv_to_ratio(nzb,j,i)*ratio2ppm*       &
+                            !                                                  kg/m^3
+                                                                             rho_air(nzb)   
+  
+
+                         ENDIF
 
                       ENDIF
@@ -1543,45 +1526,48 @@
                    k = surf_lsm_h%k(m)
 
-                   !> Distinguish between PMs (no needing conversion in ppms), 
-                   !  VOC (already converted to moles/(m**2*s) using conv_factors: they do not need molar masses for their conversion to PPMs ) and
-                   ! other Species (still expressed in Kg/(m**2*s) at this point)
-
-                   !> PMs
-                   IF (TRIM(spc_names(match_spec_model(ispec)))=="PM1"                                            &
-                         .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM25"                                    &
-                         .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM10") THEN
-
-                      !         kg/(m^2*s) * kg/m^3                           kg/(m^2*s)            
-                      surf_lsm_h%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec) *              &
-                      !                                                  kg/m^3
-                                                                       rho_air(k)   
- 
-                   ELSE
-
-                      !> VOCs
-                      IF ( len_index_voc .GT. 0 .AND. emt_att%species_name(match_spec_input(ispec))=="VOC" ) THEN
-                         !          ( ppm/s) * m * kg/m^3                        mole/(m**2/s)   
-                         surf_lsm_h%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec) *      &
-                                                                       !    m**3/mole          ppm
-                                                                       conv_to_ratio(k,j,i)*ratio2ppm*    &
-                      !                                                 kg/m^3
-                                                                       rho_air(k)   
-
-
-                      !> OTHER SPECIES
+                   IF ( emis_distribution(1,j,i,ispec) > 0.0_wp )  THEN
+
+                      !> Distinguish between PMs (no needing conversion in ppms), 
+                      !  VOC (already converted to moles/(m**2*s) using conv_factors: they do not need molar masses for their conversion to PPMs ) and
+                      ! other Species (still expressed in Kg/(m**2*s) at this point)
+
+                      !> PMs
+                      IF (TRIM(spc_names(match_spec_model(ispec)))=="PM1" .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM25"  &
+                             .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM10") THEN
+   
+                         !         kg/(m^2*s) * kg/m^3                           kg/(m^2*s)            
+                         surf_lsm_h%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec) *              &
+                         !                                                  kg/m^3
+                                                                          rho_air(k)   
+ 
                       ELSE
 
-                         !         ( ppm/s) * m * kg/m^3                        kg/(m**2/s)                      
-                         surf_lsm_h%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec) *               &
-                                                                            !  mole/Kg    
-                                                                      (1/emt_att%xm(ispec))*                          &
-                         !                                                m**3/mole           ppm
-                                                                      conv_to_ratio(k,j,i)*ratio2ppm*                 &
-                         !                                            kg/m^3
-                                                                      rho_air(k)   
+                         !> VOCs
+                         IF ( len_index_voc .GT. 0 .AND. emt_att%species_name(match_spec_input(ispec))=="VOC" ) THEN
+                            !          ( ppm/s) * m * kg/m^3                        mole/(m^2/s)   
+                            surf_lsm_h%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec) *      &
+                                                                          !    m^3/mole          ppm
+                                                                          conv_to_ratio(k,j,i)*ratio2ppm*    &
+                         !                                                 kg/m^3
+                                                                          rho_air(k)   
+
+                         !> OTHER SPECIES
+                         ELSE
+   
+                            !         ( ppm/s) * m * kg/m^3                        kg/(m^2/s)                      
+                            surf_lsm_h%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec) *               &
+                                                                               !  mole/Kg    
+                                                                         (1/emt_att%xm(ispec))*                          &
+                            !                                                m^3/mole           ppm
+                                                                         conv_to_ratio(k,j,i)*ratio2ppm*                 &
+                            !                                            kg/m^3
+                                                                         rho_air(k)   
                                                       
+                         ENDIF
+
                       ENDIF
 
                    ENDIF
+
                 ENDDO
 
@@ -1598,40 +1584,42 @@
                    k = surf_usm_h%k(m)
 
-
-                   !> PMs
-                   IF (TRIM(spc_names(match_spec_model(ispec)))=="PM1"                                     &
-                         .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM25"                             &
-                         .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM10") THEN
-                   
-                      !          kg/(m^2*s) *kg/m^3                             kg/(m^2*s)                     
-                      surf_usm_h%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec)*        & 
-                      !                                              kg/m^3
-                                                                    rho_air(k)   
-
- 
-                   ELSE
-
-                      !> VOCs
-                      IF ( len_index_voc .GT. 0 .AND. emt_att%species_name(match_spec_input(ispec))=="VOC" ) THEN
-                         !          ( ppm/s) * m * kg/m^3                        mole/(m**2/s)   
-                         surf_usm_h%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec) *   &
-                                                                       !    m**3/mole          ppm
-                                                                       conv_to_ratio(k,j,i)*ratio2ppm*    &
-                      !                                                kg/m^3
+                   IF ( emis_distribution(1,j,i,ispec) > 0.0_wp )  THEN
+
+                      !> PMs
+                      IF (TRIM(spc_names(match_spec_model(ispec)))=="PM1" .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM25"  &
+                             .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM10") THEN
+                      
+                         !          kg/(m^2*s) *kg/m^3                             kg/(m^2*s)                     
+                         surf_usm_h%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec)*        & 
+                         !                                              kg/m^3
                                                                        rho_air(k)   
 
-                      !> OTHER SPECIES
+ 
                       ELSE
 
-
-                      !            ( ppm/s) * m * kg/m^3                        kg/(m**2/s)                      
-                         surf_usm_h%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec) *      &
-                                                                          !  mole/Kg    
-                                                                      (1/emt_att%xm(ispec))*                 &
-                         !                                                m**3/mole           ppm
-                                                                      conv_to_ratio(k,j,i)*ratio2ppm*        &
-                         !                                            kg/m^3
-                                                                      rho_air(k)   
-
+                         !> VOCs
+                         IF ( len_index_voc .GT. 0 .AND. emt_att%species_name(match_spec_input(ispec))=="VOC" ) THEN
+                            !          ( ppm/s) * m * kg/m^3                        mole/(m^2/s)   
+                            surf_usm_h%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec) *   &
+                                                                          !    m^3/mole          ppm
+                                                                          conv_to_ratio(k,j,i)*ratio2ppm*    &
+                         !                                                kg/m^3
+                                                                          rho_air(k)   
+
+                         !> OTHER SPECIES
+                         ELSE
+
+
+                         !            ( ppm/s) * m * kg/m^3                        kg/(m^2/s)                      
+                            surf_usm_h%cssws(match_spec_model(ispec),m) = emis_distribution(1,j,i,ispec) *      &
+                                                                             !  mole/Kg    
+                                                                         (1/emt_att%xm(ispec))*                 &
+                            !                                                m^3/mole           ppm
+                                                                         conv_to_ratio(k,j,i)*ratio2ppm*        &
+                            !                                            kg/m^3
+                                                                         rho_air(k)   
+
+
+                         ENDIF
 
                       ENDIF
Index: palm/trunk/SOURCE/chem_modules.f90
===================================================================
--- palm/trunk/SOURCE/chem_modules.f90	(revision 3454)
+++ palm/trunk/SOURCE/chem_modules.f90	(revision 3458)
@@ -27,4 +27,8 @@
 ! -----------------
 ! $Id$
+! from chemistry branch r3443:
+! ??
+! 
+! 3298 2018-10-02 12:21:11Z kanani
 ! - Minor formatting
 ! - Introduced Variables for Chemistry emissions Module (Russo)
@@ -43,4 +47,6 @@
 ! @author Farah Kanani-Suehring
 ! @author Basit Khan
+! @author Sabine Banzhaf
+! @author Emmanuele Russo
 !
 !------------------------------------------------------------------------------!
@@ -88,4 +94,5 @@
     LOGICAL       :: do_emis                               = .FALSE.               !< Flag for turning on chemistry emissions 
     LOGICAL       :: cs_pr_namelist_found                  = .FALSE.               !< Namelist parameter: Names of t
+    LOGICAL       :: do_depo                               = .FALSE.               !< namelist parameter for activation of deposition calculation
 
 
@@ -161,4 +168,39 @@
                                                                                    ! matching between the model and the input files
 
+    
+    !-- Selected atomic/molecular weights:
+    
+    REAL, PARAMETER        ::  xm_H     =    1.00790e-3           ! kg/mol
+    REAL, PARAMETER        ::  xm_N     =   14.00670e-3           ! kg/mol
+    REAL, PARAMETER        ::  xm_C     =   12.01115e-3           ! kg/mol
+    REAL, PARAMETER        ::  xm_S     =   32.06400e-3           ! kg/mol
+    REAL, PARAMETER        ::  xm_O     =   15.99940e-3           ! kg/mol
+    REAL, PARAMETER        ::  xm_F     =   18.99840e-3           ! kg/mol
+    REAL, PARAMETER        ::  xm_Na    =   22.98977e-3           ! kg/mol
+    REAL, PARAMETER        ::  xm_Cl    =   35.45300e-3           ! kg/mol
+    REAL, PARAMETER        ::  xm_Rn222 =  222.00000e-3           ! kg/mol
+    REAL, PARAMETER        ::  xm_Pb210 =  210.00000e-3           ! kg/mol
+    REAL, PARAMETER        ::  xm_Ca    =   40.07800e-3           ! kg/mol
+    REAL, PARAMETER        ::  xm_K     =   39.09800e-3           ! kg/mol
+    REAL, PARAMETER        ::  xm_Mg    =   24.30500e-3           ! kg/mol
+    REAL, PARAMETER        ::  xm_Pb    =  207.20000e-3           ! kg/mol
+    REAL, PARAMETER        ::  xm_Cd    =  112.41000e-3           ! kg/mol
+    
+    REAL, PARAMETER        ::  xm_h2o   = xm_H * 2 + xm_O         ! kg/mol
+    REAL, PARAMETER        ::  xm_o3    = xm_O * 3                ! kg/mol
+    REAL, PARAMETER        ::  xm_N2O5  = xm_N * 2 + xm_O * 5     ! kg/mol
+    REAL, PARAMETER        ::  xm_HNO3  = xm_H + xm_N + xm_O * 3  ! kg/mol
+    REAL, PARAMETER        ::  xm_NH4   = xm_N + xm_H * 4         ! kg/mol
+    REAL, PARAMETER        ::  xm_SO4   = xm_S + xm_O * 4         ! kg/mol
+    REAL, PARAMETER        ::  xm_NO3   = xm_N + xm_O * 3         ! kg/mol
+    REAL, PARAMETER        ::  xm_CO2   = xm_C + xm_O * 2         ! kg/mol
+    
+    ! mass of air
+    REAL, PARAMETER        ::  xm_air   =  28.964e-3              ! kg/mol
+        
+    ! dummy weight, used for complex molecules:
+    REAL, PARAMETER        ::  xm_dummy =  1000.0e-3              ! kg/mol
+
+    
     SAVE
  END MODULE chem_modules
Index: palm/trunk/SOURCE/chemistry_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 3454)
+++ palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 3458)
@@ -27,4 +27,15 @@
 ! -----------------
 ! $Id$
+! from chemistry branch r3443, banzhafs, basit:
+! replace surf_lsm_h%qv1(m) by q(k,j,i) for mixing ratio in chem_depo
+! bug fix in chem_depo: allow different surface fractions for one
+! surface element and set lai to zero for non vegetated surfaces
+! bug fixed in chem_data_output_2d
+! bug fix in chem_depo subroutine
+! added code on deposition of gases and particles
+! removed cs_profile_name from chem_parin
+! bug fixed in output profiles and code cleaned
+! 
+! 3449 2018-10-29 19:36:56Z suehring
 ! additional output - merged from branch resler
 ! 
@@ -151,4 +162,5 @@
 ! @author Klaus Ketelsen
 ! @author Basit Khan
+! @author Sabine Banzhaf
 !
 !
@@ -197,5 +209,5 @@
                                  initializing_actions, message_string,                             &
                                  omega, tsc, intermediate_timestep_count,                          &
-                                 intermediate_timestep_count_max,                                  &
+                                 intermediate_timestep_count_max, max_pr_user,                     &
                                  timestep_scheme, use_prescribed_profile_data, ws_scheme_sca  
    USE arrays_3d,          ONLY: exner, hyp, pt, q, ql, rdf_sc, tend, zu
@@ -271,4 +283,61 @@
                                          ! 'fastj'  (Wild et al., 2000, J. Atmos. Chem., 37, 245-282) STILL NOT IMPLEMENTED
 
+    
+    !-----------------------------------------------------------------------
+    ! Parameter needed for Deposition calculation using DEPAC model (van Zanten et al., 2010)
+    !
+    INTEGER(iwp), PARAMETER :: nlu_dep = 15                   ! Number of DEPAC landuse classes (lu's)
+    INTEGER(iwp), PARAMETER :: ncmp = 10                      ! Number of DEPAC gas components
+    !------------------------------------------------------------------------
+    ! DEPAC landuse classes as defined in LOTOS-EUROS model v2.1                              
+    !
+    INTEGER(iwp)  ::  ilu_grass	             = 1        
+    INTEGER(iwp)  ::  ilu_arable	     = 2        
+    INTEGER(iwp)  ::  ilu_permanent_crops    = 3         
+    INTEGER(iwp)  ::  ilu_coniferous_forest  = 4         
+    INTEGER(iwp)  ::  ilu_deciduous_forest   = 5         
+    INTEGER(iwp)  ::  ilu_water_sea	     = 6        
+    INTEGER(iwp)  ::  ilu_urban      	     = 7        
+    INTEGER(iwp)  ::  ilu_other              = 8  
+    INTEGER(iwp)  ::  ilu_desert             = 9  
+    INTEGER(iwp)  ::  ilu_ice                = 10 
+    INTEGER(iwp)  ::  ilu_savanna            = 11 
+    INTEGER(iwp)  ::  ilu_tropical_forest    = 12 
+    INTEGER(iwp)  ::  ilu_water_inland       = 13 
+    INTEGER(iwp)  ::  ilu_mediterrean_scrub  = 14 
+    INTEGER(iwp)  ::  ilu_semi_natural_veg   = 15 
+    ! 
+    !--------------------------------------------------------------------------
+    ! NH3/SO2 ratio regimes:
+    INTEGER, PARAMETER  ::  iratns_low	= 1       ! low ratio NH3/SO2
+    INTEGER, PARAMETER  ::  iratns_high	= 2       ! high ratio NH3/SO2
+    INTEGER, PARAMETER  ::  iratns_very_low = 3   ! very low ratio NH3/SO2
+    ! Default:
+    INTEGER, PARAMETER  ::  iratns_default = iratns_low
+    !
+    ! Set alpha for f_light (4.57 is conversion factor from 1./(mumol m-2 s-1) naar W m-2
+    REAL(wp), DIMENSION(nlu_dep), PARAMETER :: alpha   =(/0.009,0.009, 0.009,0.006,0.006, -999., -999.,0.009,-999.,-999.,0.009,0.006,-999.,0.009,0.008/)*4.57
+    !
+    ! Set temperatures per land use for F_temp
+    REAL(wp), DIMENSION(nlu_dep), PARAMETER :: Tmin =   (/12.0, 12.0,  12.0,  0.0,  0.0, -999., -999., 12.0, -999., -999., 12.0,  0.0, -999., 12.0,  8.0/)
+    REAL(wp), DIMENSION(nlu_dep), PARAMETER :: Topt =   (/26.0, 26.0,  26.0, 18.0, 20.0, -999., -999., 26.0, -999., -999., 26.0, 20.0, -999., 26.0, 24.0 /)
+    REAL(wp), DIMENSION(nlu_dep), PARAMETER :: Tmax =   (/40.0, 40.0,  40.0, 36.0, 35.0, -999., -999., 40.0, -999., -999., 40.0, 35.0, -999., 40.0, 39.0 /)
+    !
+    ! Set F_min:
+    REAL(wp), DIMENSION(nlu_dep), PARAMETER :: F_min   =(/0.01, 0.01,  0.01, 0.1,  0.1,   -999., -999.,0.01, -999.,-999.,0.01,0.1,-999.,0.01, 0.04/)
+    
+    ! Set maximal conductance (m/s)
+    ! (R T/P) = 1/41000 mmol/m3 is given for 20 deg C to go from  mmol O3/m2/s to m/s
+    ! Could be refined to a function of T and P. in Jones
+    REAL(wp), DIMENSION(nlu_dep), PARAMETER :: g_max   =(/270., 300.,  300., 140., 150.,  -999., -999.,270., -999.,-999.,270., 150.,-999.,300., 422./)/41000
+    !
+    ! Set max, min for vapour pressure deficit vpd;
+    REAL(wp), DIMENSION(nlu_dep), PARAMETER :: vpd_max =(/1.3,  0.9,   0.9,  0.5,  1.0,   -999., -999.,1.3,  -999.,-999.,1.3,1.0,  -999.,0.9, 2.8/) 
+    REAL(wp), DIMENSION(nlu_dep), PARAMETER :: vpd_min =(/3.0,  2.8,   2.8,  3.0,  3.25,  -999., -999.,3.0,  -999.,-999.,3.0,3.25, -999.,2.8, 4.5/) 
+    !
+    !  
+    !------------------------------------------------------------------------
+
+    
     PUBLIC nest_chemistry
     PUBLIC nspec
@@ -357,4 +426,73 @@
     END INTERFACE chem_wrd_local
 
+    INTERFACE chem_depo
+       MODULE PROCEDURE chem_depo 
+    END INTERFACE chem_depo
+
+    INTERFACE drydepos_gas_depac
+       MODULE PROCEDURE drydepos_gas_depac 
+    END INTERFACE drydepos_gas_depac
+
+    INTERFACE rc_special
+       MODULE PROCEDURE rc_special 
+    END INTERFACE rc_special
+
+    INTERFACE  rc_gw
+       MODULE PROCEDURE rc_gw 
+    END INTERFACE rc_gw
+
+    INTERFACE rw_so2 
+       MODULE PROCEDURE rw_so2  
+    END INTERFACE rw_so2
+
+    INTERFACE rw_nh3_sutton
+       MODULE PROCEDURE rw_nh3_sutton 
+    END INTERFACE rw_nh3_sutton
+
+    INTERFACE rw_constant
+       MODULE PROCEDURE rw_constant 
+    END INTERFACE rw_constant
+
+    INTERFACE rc_gstom
+       MODULE PROCEDURE rc_gstom 
+    END INTERFACE rc_gstom
+
+    INTERFACE rc_gstom_emb
+       MODULE PROCEDURE rc_gstom_emb 
+    END INTERFACE rc_gstom_emb
+
+    INTERFACE par_dir_diff
+       MODULE PROCEDURE par_dir_diff 
+    END INTERFACE par_dir_diff
+
+    INTERFACE rc_get_vpd
+       MODULE PROCEDURE rc_get_vpd 
+    END INTERFACE rc_get_vpd
+
+    INTERFACE rc_gsoil_eff
+       MODULE PROCEDURE rc_gsoil_eff 
+    END INTERFACE rc_gsoil_eff
+
+    INTERFACE rc_rinc
+       MODULE PROCEDURE rc_rinc 
+    END INTERFACE rc_rinc
+
+    INTERFACE rc_rctot
+       MODULE PROCEDURE rc_rctot  
+    END INTERFACE rc_rctot
+
+    INTERFACE rc_comp_point_rc_eff
+       MODULE PROCEDURE rc_comp_point_rc_eff 
+    END INTERFACE rc_comp_point_rc_eff
+
+    INTERFACE drydepo_aero_zhang_vd
+       MODULE PROCEDURE drydepo_aero_zhang_vd 
+    END INTERFACE drydepo_aero_zhang_vd
+
+    INTERFACE get_rb_cell
+       MODULE PROCEDURE  get_rb_cell
+    END INTERFACE get_rb_cell
+
+    
 
     PUBLIC chem_3d_data_averaging, chem_boundary_conds, chem_check_data_output, &
@@ -364,5 +502,5 @@
            chem_init_profiles, chem_integrate, chem_parin,                      &
            chem_prognostic_equations, chem_rrd_local,                           &
-           chem_statistics, chem_swap_timelevel, chem_wrd_local 
+           chem_statistics, chem_swap_timelevel, chem_wrd_local, chem_depo 
 
 
@@ -838,5 +976,5 @@
 !            It is possible  to plant PM10 and PM25 into the gasphase chemistry code 
 !            as passive species (e.g. 'passive' in GASPHASE_PREPROC/mechanisms):
-!            set unit to micrograms per m**3 for PM10 and PM25 (PM2.5)
+!            set unit to kilograms per m**3 for PM10 and PM25 (PM2.5)
              IF (spec_name(1:2) == 'PM')   THEN  
                unit = 'kg m-3'
@@ -852,5 +990,5 @@
 
 
-      RETURN
+       RETURN
     END SUBROUTINE chem_check_data_output
 !
@@ -1072,5 +1210,5 @@
                          DO  k = nzb_do, nzt_do
                               local_pf(i,j,k) = MERGE(                                                &
-                                                 chem_species(lsp)%conc(k,j,i),                       &
+                                                 chem_species(lsp)%conc_av(k,j,i),                    &
                                                  REAL( fill_value, KIND = wp ),                       &
                                                  BTEST( wall_flags_0(k,j,i), 0 ) )
@@ -1104,5 +1242,4 @@
        USE surface_mod
 
-       !USE chem_modules, ONLY: nvar
 
        IMPLICIT NONE
@@ -1239,5 +1376,4 @@
 
        spec_name = TRIM( variable(4:) )
-       !av == 0
 
        DO lsp=1,nspec
@@ -1870,9 +2006,9 @@
                                         cs_name,                          &
                                         cs_profile,                       &
-                                        cs_profile_name,                  & 
                                         cs_surface,                       &
                                         decycle_chem_lr,                  &
                                         decycle_chem_ns,                  &            
-                                        decycle_method,                   & 
+                                        decycle_method,                   &
+                                        do_depo,                          &
                                         emiss_factor_main,                &
                                         emiss_factor_side,                &                      
@@ -2365,5 +2501,5 @@
                 DO lpr = 1, cs_pr_count
 
-                   sums_l(k,pr_palm+lpr,tn) = sums_l(k,pr_palm+lpr,tn) +    &
+                   sums_l(k,pr_palm+max_pr_user+lpr,tn) = sums_l(k,pr_palm+max_pr_user+lpr,tn) +    &
                                                  chem_species(cs_pr_index(lpr))%conc(k,j,i) *       &
                                                  rmask(j,i,sr)  *                                   &
